#!/usr/bin/python3

import socket
import requests
import time
from tkinter import *


def sendData(HOST,PORT,dta):
	try:
		with socket.socket(socket.AF_INET, socket.SOCK_STREAM) as s:
			s.settimeout(1)
			s.connect((HOST, PORT))
			s.send(dta.encode())
			s.sendall(b'\r')
			data = s.recv(1024)
		return repr(data)
	except Exception as E:
		pass

def VideoLightsOn():
	HOST = '192.168.1.6'  # The server's hostname or IP address
	PORT = 8000        # The port used by the server
	sendData(HOST,PORT,'actionON')
	
def VideoLightsOff():
	HOST = '192.168.1.6'  # The server's hostname or IP address
	PORT = 8000        # The port used by the server
	sendData(HOST,PORT,'actionOFF')

def CNCStatus():
	try:
		response = str(requests.get('http://192.168.1.129',verify=False,timeout=1).content).lower()
		if "relay is off" in response:
			return"Off"
		if "relay is on" in response:
			return"On"
		return"Unknown"
	except Exception as E:
		return "Unknown"
			
	
def CNCOn():
	try:
		response = requests.get('http://192.168.1.129/on',verify=False, timeout=1) 
		CncCurrentStatus="CNC Relay is " + CNCStatus()
		label1.config(text=CncCurrentStatus)
	except Exception as E:
		print(str(E))

def CNCOff():
	response = requests.get('http://192.168.1.129/off',verify=False, timeout=1)
	CncCurrentStatus="CNC Relay is " + CNCStatus()
	label1.config(text=CncCurrentStatus)


def setCNCstatus():
	st = CNCStatus()
	CncCurrentStatus="CNC Relay is " + st
	label1.config(text=CncCurrentStatus)
	window.after(2000, setCNCstatus)
	

window =Tk()
window.title("Wemos Remote")


# CNC Buttons and labels
CncCurrentStatus="CNC Relay is " + CNCStatus()
label1 = Label(window, text=CncCurrentStatus,width=20)
label1.grid(row=0,column=0,columnspan=2,sticky=N)

button1=Button(window,bg="SpringGreen3",text="CNC On",width=15,command=CNCOn).grid(row=1, column=0, sticky=E)
button2=Button(window,bg="firebrick1",text="CNC Off",width=15,command=CNCOff).grid(row=1, column=1, sticky=E)
# update the cnc label every 2 seconds
window.after(2000, setCNCstatus)

# Video Lights
label2 = Label(window, text="\nVideo Lights", width=20)
label2.grid(row=2,column=0,columnspan=2,sticky=N)
button3=Button(window,bg="SpringGreen3",text="Video Lights ON", width=15,command=VideoLightsOn)
button3.grid(row=3,column=0,sticky=W)
button4=Button(window,bg="firebrick1",text="Video Lights OFF", width=15,command=VideoLightsOff)
button4.grid(row=3,column=1,sticky=E)

# start the main loop
window.mainloop()
